#include <iostream>
#if !defined(SRM_VECTOR_H_)
#define SRM_VECTOR_H_

class Vector
{
    friend std::ostream &operator<<(std::ostream &out, const Vector &vec);
    friend std::istream &operator>>(std::istream &in, Vector &vec);

private:
    int *data;
    int size;
    int capacity;

public:
    Vector();
    Vector(const Vector &vec);
    Vector(int *arr, int num);
    ~Vector();

    Vector &operator=(const Vector &vec);
    int &operator[](int index) const;
    Vector operator+(const Vector &vec);
    Vector &operator++();
    const Vector operator++(int);

    int get_size() const { return size; };
    int get_capacity() const { return capacity; };
    bool empty() const { return size == 0; };

    int at(int index) const;
    int pop_back();
    void push_back(int elem);
    void reserve(int new_capc);
    void shrink_to_fit();
    void insert(int pos, int num = 1, int elem = int());
    void erase(int first, int last);
    void erase(int index);
    static void swap(Vector &v1, Vector &v2);
};

#endif // SRM_VECTOR_H_